//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


#include "History.h"




void History::pushUrl(const char *url) {
    if(count>=HISTORY_SIZE-1) {
	// If buffer is full, pop off the 1st element
	for(int i=0; i<count-1; i++)
	    history[i]=history[i+1];
	// adjust count
	count--;
    }
    // Add url to history
    history[count++]=strdup(url);
 }

char *History::popUrl() {
    char *result;
    if(count>0) {
	count--;
	result=history[count];
    } else 
	result=NULL;
    return result;
}




History::History() {
    count=0;
}

History::~History() {
    for(int i=0; i<count; i++) {
	free(history[i]);
	history[i]=NULL;
    }
}
