//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


typedef void (LinkHandlerFunc )(const char *);
typedef void (LeftHandlerFunc )();


class HtmlDisplay : public Fl_Group {

private:
    Fl_Scrollbar xscroll;
    Fl_Scrollbar yscroll;
    
    // Offset of the scroll bars
    short viewx;
    short viewy;
    short vieww;
    short viewh;


    // The HTML container object
    HtmlData *htmlData;
    // Array of currently active links
    VisLinkArray *visibleLinks;
    
    void updateScrollbars();

    LinkHandlerFunc *linkHandler;
    LeftHandlerFunc *leftHandler;


public:
    static const short frame_size=4;
    static const short scrollbar_size=8;
    HtmlDisplay(int x, int y, int w, int h, const char *label);
    //void setContent(Html *html);
    void draw();
    int handle(int event);
    void clear();
    void setLinkHandler(LinkHandlerFunc *func) { linkHandler=func; }
    void setLeftHandler(LeftHandlerFunc *func) { leftHandler=func; }
    void load(const char *fileName);
    void resize(int newx, int newy, int neww, int newh);
    const char *getHead() { 
	return htmlData!=NULL ? htmlData->getHead() : NULL; 
    }
};
