//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <stdlib.h>
#include <stdio.h>
#ifdef DMALLOC
#include <dmalloc.h>
#endif

#include "LinkArray.h"

LinkArray::LinkArray() {
    stack=(Link *) calloc(increment, sizeof(Link));
    alloc=increment;
    count=0;
}

LinkArray::~LinkArray() {
    clear();
    free((void *) stack);
}

void LinkArray::clear() {
    for(int i=0; i<count; i++)
	free(stack[i].target);
    // reset count to 0
    count=0;
}

short LinkArray::addLink(char *target) {
    if(count>=alloc) {
	alloc+=increment;
	stack = (Link *) realloc(stack, sizeof(Link)*alloc);
    }
    Link *link = &stack[count++];
    link->target=target;
    return count-1;
}

