//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <stdlib.h>
#ifdef DMALLOC
#include <dmalloc.h>
#endif
#include "LineDef.h"
#include "Para.h"

Para::Para(LineDef *ld) {
    init(ld);
}

Para::Para(LineDef *ld, short w2, short x2) {
    init(ld);
    w=w2;
    x=x2;
}

void Para::init(LineDef *ld) {
    lineDef=ld;
    w=0;
    h=0;
    x=0;
    y=0;
    posx=0;
    posy=0;
    number=0;
    curLineIdx=lineDef->newLine();
}

void Para::maxLineSize(short size) {
    lineDef->testSize(curLineIdx, size);
}


void Para::compareWidth(short w2) {
    if(/*x+*/w2>w)
	w=w2;
}

short Para::nextNumber() {
    return number++;
}

int Para::newLine() {
    posy+=lineDef->maxSize(curLineIdx)+2;
    curLineIdx=lineDef->newLine();
    posx=0;
    return curLineIdx;
}

short Para::getLineSize() {
    return lineDef->maxSize(curLineIdx);
}
