//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <stdlib.h>
#include <stdio.h>
#ifdef DMALLOC
#include <dmalloc.h>
#endif
#include "Table.h"


Table::Table() {
    colCount=0;
    colAlloc=10;
    mincols=(short *) calloc(colAlloc,sizeof(*mincols));
    cols=(short *) calloc(colAlloc,sizeof(*cols));
    curCol=0;

    rowCount=0;
    rowAlloc=20;
    rows=(short *) calloc(rowAlloc,sizeof(*rows));
    curRow=0;

    outerFrame=2;
    borderWidth=1;
    innerFrame=2;

}

Table::~Table() {
    free(cols);
    free(rows);
}


void Table::setMinColWidth(int i, short width) {
    while(i>=colAlloc) {
	colAlloc+=10;
	mincols=(short *) realloc(mincols, sizeof(*mincols)*colAlloc);
	cols=(short *) realloc(cols, sizeof(*cols)*colAlloc);
    }
    if(colCount<i+1)
	colCount=i+1;
    if(mincols[i]<width)
	mincols[i]=width;
}

short Table::getColWidth(int i) {
    return cols[i];
}

short Table::getMinColWidth(int i) {
    return mincols[i];
}


void Table::setRowHeight(int i, short height) {
    while(i>=rowAlloc) {
	rowAlloc+=10;
	rows=(short *) realloc(rows, sizeof(*rows)*rowAlloc);
    }
    if(rowCount<i+1)
	rowCount=i+1;
    if(rows[i]<height)
	rows[i]=height;
}

short Table::getRowHeight(int i) {
    return rows[i];
}

void Table::expand(short width) {
//    short minWidth=0;
    for(int i=0; i<colCount; i++) {
	cols[i]=mincols[i];
//	minWidth+=mincols[i];
    }
    short delta = width-minW;
    if(delta>0) {
	for(int i=0; i<colCount; i++) {
	    short extra = delta/(colCount-i);
	    delta-=extra;
	    cols[i]+=extra;
	}
    }
    w=width;
}
