//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <stdlib.h>
#ifdef DMALLOC
#include <dmalloc.h>
#endif

#include "Table.h"
#include "TableStack.h"

TableStack::TableStack() {
    stack=(Table **) calloc(increment, sizeof(Table *));
    alloc=increment;
    count=0;
}

TableStack::~TableStack() {
    clear();
    free((void *) stack);
    // There is a memory leak here! Table objects are not freed when
    // removed from the stack (shoud they?)
}


void TableStack::push(Table* &current, int elemIndex) {
    if(count>=alloc) {
	alloc+=increment;
	stack = (Table **) realloc(stack, sizeof(Table *)*alloc);
    }
    stack[count++]=current;
    current = new Table();
    current->elemIndex=elemIndex;
}

void TableStack::pop(Table* &current) {
    if(count>0) count--;
    current=stack[count];
}

void TableStack::clear() {
    for(int i=0; i<count; i++) {
	delete(stack[i]);
    }
   count=0;
}
