//
// Copyright (C) 2002 Henning Spruth

// Written by Henning Spruth <henning.spruth@epost.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


typedef enum {URL_INVALID, URL_HTTP, URL_FILE, URL_ZIP} UrlType;


class Url {


private:
    // The original URL
    char *url;

    // The host name, or NULL for type URL_FILE
    char *host;

    // The full path name of the item
    char *path;

    // The directory part of the above
    char *dir;

    UrlType type;
    bool implicit;

    int isImplicitHttp(char *);
    char *newDirectoryPartOf(char *);
    void setTypeAndHost();
    
public:

    Url(const char *url);
    Url();
    void set(const char *url);
    void clear();
    ~Url();
    
    UrlType getType() {return type;}
    const char *getUrl() {return url;}
    const char *getHost() { return host;}
    const char *getPath() { return path; }
    const char *getDir() { return dir; }
    bool isImplicit() { return implicit; }
    
};
